/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.frontend.taglib.util.internal;

import com.liferay.frontend.js.loader.modules.extender.npm.NPMResolver;
import com.liferay.frontend.taglib.util.TagAccessor;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.framework.FrameworkUtil;
import org.osgi.framework.ServiceReference;

/**
 * @author Iván Zaera Avellón
 */
public class NPMResolverRef implements AutoCloseable {

	public NPMResolverRef(TagAccessor tagAccessor) {
		Bundle bundle = FrameworkUtil.getBundle(tagAccessor.getClass());

		_bundleContext = bundle.getBundleContext();

		_serviceReference = _bundleContext.getServiceReference(
			NPMResolver.class);

		_npmResolver = _bundleContext.getService(_serviceReference);
	}

	@Override
	public void close() {
		_bundleContext.ungetService(_serviceReference);
	}

	public NPMResolver getNPMResolver() {
		return _npmResolver;
	}

	private final BundleContext _bundleContext;
	private final NPMResolver _npmResolver;
	private final ServiceReference<NPMResolver> _serviceReference;

}